<?php
/*
 * $Horde: imp/ldappasswd.php,v 1.12 2000/11/07 22:21:41 chuck Exp $
 *
 * Copyright 2000 Jean Charles Delepine <delepine@u-picardie.fr>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

if (!defined('HORDE_LIB')) include '../lib/horde.lib';
require './lib/imp.lib';           /* IMPlib is the IMP function library  */
require '../config/horde.php3';
require './config/defaults.php3';  /* Defaults configuration file */
error_reporting($default->error_level);
$language = Lang::select();
require "./locale/$language/passwd.lang";
require './locale/local/passwd.lang';

/* add help in future */
/* require "./help/defines/passwd.help"; */

/* retrieve authentication information from session */
session_name($horde['session_name']);
@session_start();

if (!isset($imp) || !is_object($imp)) { header('Location: ' . Horde::url('login.php3?reason=logout', true)); exit; }
$imp->unpickle();
$imp->authenticate();

/* doctype */
require "$default->include_dir/doctype.inc";

/* Get the ldappassd server from defaults, otherwise set to safe values */

if (isset($default->ldappassd_base) 
    && isset($default->ldappassd_cn)) {
    $ldappassd_server= $default->ldappassd_server;
    $ldappassd_base=$default->ldappassd_base;
    $ldappassd_cn=$default->ldappassd_cn;
    if (isset($default->ldappassd_server)) {
        $ldappassd_port=$default->ldappassd_server;
    } else {
        $ldappassd_server='localhost';
    }
    if (isset($default->ldappassd_port)) {
        $ldappassd_port=$default->ldappassd_port;
    } else {
        $ldappassd_port=389;
    }
} else {
    $ldappassd_base='';
}

/* run through ActionIDs */
if (isset($actionID)) {
    switch ($actionID) {
    case NO_ACTION:
        break;
        
    case PASSWD_INPUT:
        include "$default->include_dir/passwd/ldappassd_input.inc";
        break;
        
    case PASSWD_DISALLOW:
        $errortype = 'nopermission';
        include "$default->include_dir/passwd/ldappassd_error.inc";
        break;
        $username=$imp->user;  
    case PASSWD_CHANGE:	        /* now we change the passwd */
        /* error checking */
        if (!($username == $imp->user)) {
            $errortype = 'username';
            include "$default->include_dir/passwd/ldappassd_error.inc";
        } 
        if (strcmp($old_pass, $imp->pass) != 0) {
            $errortype = 'old_pass';
            include "$default->include_dir/passwd/ldappassd_error.inc";
        }
        if (strlen($new_pass) <= 4) {
            $errortype = 'short_pass';
            include "$default->include_dir/passwd/ldappassd_error.inc";
        }
        if (strcmp($new_pass, $new_pass2) != 0) {
            $errortype = 'new_pass_ne';
            include "$default->include_dir/passwd/ldappassd_error.inc";
        }
    
        /* OK, the input data seems to be OK, connect */
        $ds = ldap_connect("$ldappassd_server", $ldappassd_port);
        $dc = "$ldappassd_cn=" . "$imp->user" . "," . "$ldappassd_base";
        
        if ($ds) {
            $r = ldap_bind($ds, $dc , $imp->pass); 
            if ($r) {
                $info['userpassword'] = $new_pass;
                
                // add data to directory
                $r = ldap_modify($ds, $dc, $info);
                
                ldap_close($ds);
                
                echo '<script language=javascript>
                 window.location="login.php3?reason=chpass";
              </script>';
                exit;
            } else {
                $errortype = "bind to ldap server failed";
                include "$default->include_dir/passwd/ldappassd_error.inc";
                exit;
            }
        } else {
            $errortype = "connection to ldap server failed";
            include "$default->include_dir/passwd/ldappassd_error.inc";
            exit;
        }
        break;
        
    default:
        include "$default->include_dir/passwd/ldappassd_input.inc";
    }
} else {
    include "$default->include_dir/passwd/ldappassd_input.inc";
}

?>
