<?php
// $Horde: imp/lib/mimetypes.php,v 1.44 2001/01/10 20:12:27 chuck Exp $

function mime_action_images ($mime) {
    $ret = '';
    $mime->action['action'] = 'default';
    $ret .= $mime->display();
    if ($mime->size < 10000 && ($mime->subtype == 'gif' || $mime->subtype == 'jpeg')) {
        $ret .= '</td><td>&nbsp;&nbsp;';
        $ret .= '<img src="view.php?mailbox=' . urlencode($mime->mailbox) . "&index=$mime->index&id=$mime->partno&actionID=" . VIEW_ATTACH . '" />';
    }
    return $ret;
}

function mime_view_html ($mime) {
    $data = IMP_Util::getDecodedPart($mime);
    
    /* These regular expressions attempt to make html safe for
    * viewing. THEY ARE NOT PERFECT. If you enable html viewing, you
    * are opening a security hole. With the current state of the web,
    * I believe that the best we can do is to make sure that people
    * _know_ html is a security hole, clean up what we can, and leave
    * it at that. */
    $data = preg_replace("|<([^>]*)script|i", "<imp_cleaned_script_tag", $data);
    $data = preg_replace("|<([^>]*)embed|i", "<imp_cleaned_embed_tag", $data);
    $data = preg_replace("|<([^>]*)java|i", "<imp_cleaned_java_tag", $data);
    $data = preg_replace("|<([^>]*)object|i", "<imp_cleaned_object_tag", $data);
    $data = preg_replace("|<([^>]*)style|i", "<imp_cleaned_style_tag", $data);
    $data = preg_replace("|href=\"(.*)script:|i", "href=\"imp_cleaned_script:", $data);
    $data = preg_replace("|<([^>]*)&{.*}([^>]*)>|i", "<&{;}\\3>", $data);
    $data = preg_replace("|<([^>]*)mocha:([^>]*)>|i", "<imp_cleaned_mocha:\\2>", $data);
	
    // search for embedded images that we can display
    global $MimeID, $imp, $index;
    if (isset($MimeID)) {
        foreach ($MimeID as $ref => $id) {
            if (strlen($id) > 0) {
                if ($id[0] == '<') $id = substr($id, 1);
                if ($id[strlen($id) - 1] == '>') $id = substr($id, 0, strlen($id)-1);
                $data = str_replace("cid:$id", Horde::url('view.php?actionID=' . VIEW_ATTACH . '&index=' . $mime->index . '&mailbox=' . urlencode($imp['mailbox']) . '&id=' . $ref), $data);
            }
        }
    }
  
    return $data;
}

function mime_view_msword ($mime) {
	global $conf;
	$content = IMP_Util::getPart($mime);
	
	$tmp_word = tempnam('/tmp', 'imp_word');
	_fileCleanup($tmp_word);
	
	$fh = fopen($tmp_word, 'w');
	fwrite($fh, imap_base64($content));
	fclose($fh);
	
	$pipe = popen($conf['utils']['wordviewer'] . " $tmp_word 2>&1", 'r');
	$data = '';
	while (($rc = fgets($pipe, 8192))) {
	    $data .= $rc;
    }
	
    pclose($pipe);
	unlink($tmp_word);
	
	return $data;
}

function mime_view_xls ($mime) {
    global $conf;
    $content = IMP_Util::getDecodedPart($mime);
    
    $tmp_xls = tempnam('/tmp', 'imp_xls');
    _fileCleanup($tmp_xls);
    
    $fh = fopen($tmp_xls, 'w');
    fwrite($fh, $content);
    fclose($fh);
    
    $pipe = popen($conf['utils']['excelviewer'] . " $tmp_xls 2>&1", 'r');
    while (($rc = fgets($pipe, 8192))) {
        $data .= $rc;
    }
    
    pclose($pipe);
    unlink($tmp_xls);
    
    return $data;
}

function mime_view_rpm ($mime) {
	global $conf;
	
	$content = IMP_Util::getPart($mime);
	
	$tmp_rpm = tempnam('/tmp', 'imp_rpm');
	_fileCleanup($tmp_rpm);
	
	$fh = fopen($tmp_rpm, 'w');
	fwrite($fh, imap_base64($content));
	fclose($fh);
	
	$pipe = popen( $conf['utils']['rpm'] . " -qip $tmp_rpm 2>&1", 'r' );
	$data = '<b><u>Query RPM Package</u></b><br /><table><tr><td align=left><pre>';
	
	$re = '';
	while (($rc = fgets($pipe, 10)))
		$re .= $rc;
	pclose($pipe);
    unlink($tmp_rpm);
	$data .= htmlentities($re);
	$data .= '</pre></td></tr></table>';
	
	return $data;
}

function mime_view_text ($mime) {
    global $conf, $prefs;
    
    $text = IMP_Util::getDecodedPart($mime);
    if (strtolower($mime->charset) == 'windows-1251') {
        $text = convert_cyr_string($text, 'w', 'k');
    }
    
    $text = str_replace('</A>', '</a>', $text); // make sure that the original message doesn't contain any capital </A> tags, so we can assume we generated them
    $text = str_replace('<A', '<a', $text);     // ditto for open <A> tags
    $text = preg_replace('|(\w+)://([^\s"<]*)([\w#?/&=])|', '<A href="\1://\2\3" target="_blank">\1://\2\3</A>', $text);
    $text = preg_replace('|[Mm][Aa][Ii][Ll][Tt][Oo]:(\s?)([\w+-=%&:_.~@]+[#\w+]*)|e', "'mailto:\\1<A href=\"' . IMP::composeLink(array('to' => '\\2')) . '\">\\2</A>'", $text);
    $text = htmlspecialchars($text);
    $text = str_replace('&lt;A href=&quot;', '<a class="fixed" href="', $text);
    $text = str_replace('&quot; target=&quot;_blank&quot;&gt;', '" target="_blank">', $text);
    $text = str_replace('&quot;&gt;','">', $text);
    $text = str_replace('\');&quot;&gt;', '\');">', $text);
    $text = str_replace('&lt;/A&gt;', '</a>', $text); // only reconvert capital /A tags - the ones we generated
    
    // highlight quoted parts of an email
    $text = implode("\r\n", preg_replace('|^(\s*&gt;.+)$|', '<span class="quoted">\1</span>', explode("\r\n", $text)));

    // filter bad language
    if ($prefs->getValue('filtering')) {
        $text = Text::filter($text, $conf['msg']['filtering']['words'],
            $conf['msg']['filtering']['replacement']);
    }

    // wordwrap
    $text = str_replace('  ', ' &nbsp;', $text);
    $text = str_replace("\n ", "\n&nbsp;", $text);
	if ($text[0] == ' ') $text = '&nbsp;' . substr($text, 1);
    $text = nl2br($text);
    
    return '<p class="fixed">' . $text . '</p>';
}

function mime_view_tgz ($mime) {
    global $conf;
    
    $content = IMP_Util::getPart($mime);
    
    $tmp_tgz = tempnam('/tmp', 'imp_tgz');
    _fileCleanup($tmp_tgz);
    
    $fh = fopen($tmp_tgz, 'w');
    fwrite($fh, imap_base64($content));
    fclose($fh);
    
    $pipe = popen($conf['utils']['tar'] . " tvzf $tmp_tgz 2>&1", 'r');
    $data = '<b><u>Query Gzipped Tarball</u></b><br /><table><tr><td align=left><pre>';
    
    $re = '';
    while (($rc=fgets($pipe,10)))
      $re .= $rc;
    pclose($pipe);
    unlink($tmp_tgz);
    
    $data .= htmlspecialchars($re);
    $data .= '</pre></td></tr></table>';
    
    return $data;
}

function mime_view_php ($mime) {
    ob_start();
    
    highlight_string(IMP_Util::getDecodedPart($mime));
    $contents = ob_get_contents();
    ob_end_clean();
    
    return $contents;
}

function mime_view_tar ($mime) {
	global $conf;
  
	$content = IMP_Util::getPart($mime);
	
	$tmp_tar = tempnam('/tmp', 'imp_tar');
	_fileCleanup($tmp_tar);
	
	$fh = fopen($tmp_tar, 'w');
	fwrite($fh, imap_base64($content));
	fclose($fh);
  
	$pipe = popen($conf['utils']['tar'] . " tvf $tmp_tar 2>&1", 'r');
	$data = '<b><u>Query Tarball</u></b><br /><table><tr><td align=left><pre>';
	
	$re = '';
	while (($rc=fgets($pipe,10)))
		$re .= $rc;
	pclose($pipe);
    unlink($tmp_tar);
	
	$data .= htmlspecialchars($re);
	$data .= '</pre></td></tr></table>';
	
	return $data;
}

function mime_view_zip ($mime) {
	global $conf;
	
	$content = IMP_Util::getPart($mime);
	
	$tmp_zip = tempnam('/tmp', 'imp_zip');
	_fileCleanup($tmp_zip);
	
	$fh = fopen($tmp_zip, 'w');
	fwrite($fh, imap_base64($content));
	fclose($fh);
	
	$pipe = popen($conf['utils']['unzip'] . " -m $tmp_zip  2>&1 |grep -v Archive", 'r');
	$data = '<b><u>Contents of ZIP file</u></b><br /><table><tr><td align=left><pre>';
	while (($rc=fgets($pipe,10)))
		$data.= $rc;
	pclose($pipe);
	$data .= '</pre></td></tr></table><br /><b><u>Details of ZIP file</u></b><br /><table><tr><td align="left"><pre>';
	$pipe = popen($conf['utils']['unzip'] . " -mvh $tmp_zip  2>&1 |grep -v Archive", 'r');
	while (($rc=fgets($pipe,10)))
		$data.= $rc;
	pclose($pipe);
    unlink($tmp_zip);
	$data .= '</pre></td></tr></table>';
	
	return $data;
}

function mime_view_deb ($mime) {
	global $conf;
	
	$content = IMP_Util::getPart($mime);
	
	$tmp_deb = tempnam('/tmp', 'imp_deb');
	_fileCleanup($tmp_deb);
	
	$fh = fopen($tmp_deb, 'w');
	fwrite($fh, imap_base64($content));
	fclose($fh);
	
	$pipe = popen( $conf['utils']['dpkg'] . " -f $tmp_deb 2>&1", 'r' );
	$data = '<b><u>Query Debian Package</u></b><br /><table><tr><td align=left><pre>';
	
	$re = '';
	while(($rc=fgets($pipe,10)))
		$re.= $rc;
	pclose($pipe);
    unlink($tmp_deb);
	$data .= htmlentities($re);
	$data .="</pre></td></tr></table>";
	
	return $data;
}

function mime_view_gpg_sig ($mime) {
	global $conf, $imp, $index, $attachments;
	
	$content = IMP_Util::getPart($mime);
	
	$tmp_gpg = tempnam('/tmp', 'imp_gpg');
	_fileCleanup($tmp_gpg);
	
	$fh = fopen($tmp_gpg, 'w');
	fwrite($fh, $content);
	fclose($fh);
	
	$tmp_gpg_body = tempnam('/tmp', 'imp_gpg_body');
	_fileCleanup($tmp_gpg_body);
	
	// the - 1 here seems pretty iffy...
	$tmsg = @imap_fetchbody($imp['stream'], $index, $mime->imap_id - 1, FT_UID);
	$hmsg = '';
	
	$mimetmp = $attachments[$mime->imap_id];
	if ($mimetmp->encoding == ENCQUOTEDPRINTABLE) {
		$hmsg = "Content-Transfer-Encoding: quoted-printable\n";
	} else if ($mimetmp->encoding == ENCBASE64) {
		$hmsg = "Content-Transfer-Encoding: base64\n";
	}
	
	// what should the default be here?
	$texttype = 'text/plain';
	if ($mimetmp->type == TYPETEXT) {
		$texttype = 'text/plain';
	}
	
	$rmsg = "Content-Type: " . $texttype . "; charset=" . $mimetmp->charset . "\n";
	$rmsg .= $hmsg;
	$rmsg .= "\n";
	$rmsg .= $tmsg;
	$fi = fopen($tmp_gpg_body, 'w');
	fwrite($fi, $rmsg);
	fclose($fi);
	
	$gpg_flags = '';
	
	if ($conf['pgp']['type'] == 'gpg') {
		$gpg_flags = '--keyserver ' . $conf['pgp']['keyserver'] . ' --load-extension rsa --load-extension idea --no-verbose --batch -o - --verify';
	} elseif ($conf['pgp']['type'] == 'pgp2') {
		$gpg_flags = '+batchmode ';  // need pgp2 flags
	} elseif ($conf['pgp']['type'] == 'pgp5') {
		$gpg_flags = '';  // need pgp5 flags
	}
	
	$pipe = popen('export HOME=' . $conf['pgp']['conf_dir'] . ';' . $conf['utils']['gpg'] . " $gpg_flags $tmp_gpg $tmp_gpg_body 2>&1", 'r');
	$data = '<b><u>Verification of GPG/PGP Signature</u></b><br /><table><tr><td align=left><pre>';
	
	$re = '';
	while (($rc = fgets($pipe,10)))
		$re .= $rc;
	pclose($pipe);
    unlink($tmp_gpg);
    unlink($tmp_gpg_body);
	$data .= htmlentities($re);
	$data .= '</pre></td></tr></table>';
	
	return $data;
}

?>
