<?php
/*
 * $Horde: imp/remote_login.php,v 1.26 2000/12/02 20:05:55 chuck Exp $
 *
 * Copyright 1999, 2000 Charles J. Hagenbuch <chuck@horde.org>
 * Copyright 1999, 2000 Jon Parise <jon@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

require_once './lib/base.php';

session_name($horde['session_name']);
@session_start();

if ((isset($HTTP_GET_VARS['action']) && $HTTP_GET_VARS['action'] == 'compose') ||
    (isset($HTTP_POST_VARS['action']) && $HTTP_POST_VARS['action'] == 'compose')) {
    $actionID = LOGIN_COMPOSE;
} else {
    $actionID = IMP_LOGIN;
}

/* If we already have a session... */
if (isset($imp) && is_array($imp)) {
	/* Make sure that if a username was specified, it is the current username */
	if ((!isset($imapuser) || $imapuser == $imp['user']) &&
        (!isset($pass) || $pass == Secret::read(IMP::getKey(), $imp['pass']))) {
		/* Redirect the user to the mailbox listing. */
		header('Location: ' . Horde::url('mailbox.php?actionID=' . $actionID, true));
		exit;
	} else {
		/* Disable the old session. */
		$imp = false;
		session_unregister('imp');
        header('Location: ' . Horde::url(logoutURL('login.php?reason=failed'), true));
        exit;
	}
}

/* Create a new session if we're given the proper parameters. */
if (isset($imapuser) && isset($pass)) {
    if (!isset($mailbox)) $mailbox = 'INBOX';
    IMP::createSession();
    if (IMP::authenticate()) {
		header('Location: ' . Horde::url('mailbox.php?actionID=' . $actionID, true));
        exit;
    } else {
        header('Location: ' . Horde::url(logoutURL('login.php?reason=failed'), true));
        exit;
    }
}

?>
