#!/usr/bin/perl

# RELEASE: 1999-07-21
# CURRENT DATE: 1999-10-07
# VERSION: 2.0
# pine2imp.pl
# AUTHOR: Christopher Murley murley@murley.com
###############################################

# These are the database variables - Adjust these to your specs.
####### Define Main Vars ##########
$Machine = "db.netexpress.net";
$UserName = "murley";
$PassWord = "TopherDeon";
$DataBase = "impdb2";
$TableName = "imp_addr";
###################################

# This is the perl DBI module - to talk to databses - available at CPAN
use DBI; 

&Displayhead;
&Status("Connecting to database....");
&Status("If you do not see any more output the screen wihtin 1 minute,");
&Status("stop this operation by using control-c and adjust the \$Machine variable.");
&Status("-------------------------------------------------------------------------");


# Check to make sure we have command line arguments present.

if (@ARGV == "") {
        &DisplayUsage;
        exit;
}

# Get arguments and assign them to varibles for use

foreach $Argument (@ARGV) {
    # Check for proper email
    if($Argument =~ /--email=(.*)/) {
        $Options_Email = $1;
    # Check to see if home directory is given
    } elsif($Argument =~ /--home=(.*)/) {
        $Options_HomeDir = $1;
    # Check for address file name
    } elsif($Argument =~ /--address=(.*)/) {
        $Options_Address = $1;
    # We have no idea what this is
    } else {
        &DisplayUsage;
        exit;
    }
}

# Check to make sure we have data in each variable.

if ($Options_Email eq "" || $Options_HomeDir eq "" || $Options_Address eq "" ) {
        &DisplayUsage;
        exit;
}

# Check to see if the home directory they gave us ends with a trailing slash
# If it does, we need to remove it to avoid file open problems later....

$HomeDirLen = length($Options_HomeDir);
$CheckSlash = substr($Options_HomeDir, ($HomeDirLen -1), 1);
if ($CheckSlash eq "\/") {
  $Options_HomeDir = substr($Options_HomeDir, 0, ($HomeDirLen -1));
}

# Check to see if the addressbook file is where they told us it was.    

if (!(-e "$Options_HomeDir/$Options_Address")) {
	&Status("\n\n##### The file $Options_HomeDir/$Options_Address does not exist. #####\n\n");
        exit;
}

# Open the address file and start to parse

open(ADDR, "$Options_HomeDir/$Options_Address") || die "Error opening address file: $!";

# Connect to the databse they specified above

$dbh = DBI->connect("DBI:mysql:$DataBase:$Machine:3306", $UserName, $PassWord) or die "Can't connect to database: $dbh->errstr";

#Set some vars to keep track of the entries we find

$Incremented = "0";
$TFinal = "0";
    while (<ADDR>) {
	$Line = $_;
	chomp($Line); # Cut the return char off the string
        $FullFileArray[$Incremented] = $Line; # Add to array for checking multiple-line addresses
        $Incremented++; # increment array counter
        $TempCheck = ($Incremented -2); # Previous Line Num
        $CHeckIndentPreLine = substr($FullFileArray[$TempCheck], 0, 3); # Check for 3 space indent
        $CheckIndent = substr($Line, 0, 3); # Check for 3 space indent

        if ($CheckIndent ne "   ") {
             $HARRAY[$TFinal] = $Line;
             $LastKey = $TFinal;
             $TFinal++;
        } elsif ($CheckIndent eq "   " && $CHeckIndentPreLine ne "   ") {
              $Len = length($Line);  # Get length of var
              $Line = substr($Line, 3, ($Len -3)); # Remove spaces from this var
              $HARRAY[$LastKey] .= $Line;
        } elsif ($CheckIndent eq "   " && $CHeckIndentPreLine eq "   ") {
              $Len = length($Line);  # Get length of var
              $Line = substr($Line, 3, ($Len -3)); # Remove spaces from this var
              $HARRAY[$LastKey] .= $Line;
        } else {
              &Status("\n\n##### Invalid address entry.... ignoring. #####\n\n");           
        }

    }
close ADDR;


$DatabaseKey = "0";
# FORMAT OF ADDRESSBOOK - nickname <TAB> Full Name <TAB> Email Address <TAB> FCC: <TAB> Comment
while ($DatabaseKey <= ($TFinal -1)) {
        $CheckValidLine = $HARRAY[$DatabaseKey]; # Assign the value to a var we can mangle ;-)        
        $CheckValidLine =~ s/ //g; # Remove any spaces in the string
        $CheckValidLine =~ s/\t//g; # Remove any tabs in the string
	if ($CheckValidLine ne "") { #Make sure the line isn't a blank line
	    ($Nick, $FullName, $Addr, $Fcc, $Comment) = split(/\t/, $HARRAY[$DatabaseKey]); # Split the string into seperate vars.
            if ($Addr eq "") {
              &Status("\n\n##### Invalid address entry.... ignoring. #####\n\n");           
            } else {
  	      $Query = "insert into $TableName(user, address, nickname, fullname) values('$Options_Email', '$Addr', '$Nick', '$FullName')";
	      $sth = $dbh->prepare($Query) or die "Can't execute the query: $dbh->errstr";
	      $rv = $sth->execute or die "Can't execute the query: $dbh->errstr";
              &Status("-----> Added Entry: $Nick to IMP addressbook...");
           }
        }
$DatabaseKey++;



}

&Status("\n\n***** Import to IMP complete! *****\n\n");

sub DisplayUsage {

print "\n\nUsage: pine2imp.pl --email=[email\@domain] --home=[/home/username] --address=[.addressbook]\n\n";
exit;

}

sub Displayhead {
print "\n\n\n";
print "###########################################\n";
print "#                                         #\n";
print "#           Pine(tm) to IMP(tm)           #\n";
print "#                                         #\n";
print "#    Imports pine addressbooks into IMP   #\n";
print "#                                         #\n";
print "#               Version 2.0               #\n";
print "#                                         #\n";
print "#          By: Christopher Murley         #\n";
print "###########################################\n\n\n";

}


sub Status {
 local($Msg) = @_;
 print "\n$Msg\n";
}

