<?php
/*
 * $Horde: imp/search.php,v 2.60 2001/01/10 19:24:22 chuck Exp $
 *
 * Copyright 1999, 2000 Charles J. Hagenbuch <chuck@horde.org>
 * Copyright 1999, 2000 Jon Parise <jon@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

require_once './lib/base.php';
require_once '../lib/Registry.php';

$registry = new Registry();

/* Retrieve authentication information from the session. */
session_name($horde['session_name']);
@session_start();

if (!isset($HTTP_SESSION_VARS['imp']) || !is_array($HTTP_SESSION_VARS['imp'])) {
    header('Location: ' . Horde::url('login.php?reason=logout', true));
    exit;
}
IMP::setupSession();
IMP::authenticate(OP_HALFOPEN);

if ($conf['compress_pages']) {
    HTTP_Cache::start();
}

$title = _("Message Search");
require $conf['paths']['templates'] . '/doctype.inc';
require $conf['paths']['templates'] . '/common-header.inc';
require './menu.php';

$newcol = 1;
$numcolumns = 1;
$search_folders = '';
$mailboxes = IMP::flist();
$total = count($mailboxes);
foreach ($mailboxes as $mbox) {
    $newcol++;
    $search_folders .= '<input type="checkbox" name="search_folders[]" ';
    $search_folders .= 'value="' . $mbox['val'] . '"';
    if ($mbox['label'] == 'INBOX') {
        $search_folders .= ' checked="checked"';
    }
    $search_folders .= ' />' . $mbox['label'] . "<br />\n";
    
    if (($newcol > ceil($total / 3)) && ($numcolumns != 3)) {
        $newcol = 1;
        $numcolumns++;
        $search_folders .= "</td>\n";
        $search_folders .= '<td class="control" valign="top" align="left">';
    }
}

require $conf['paths']['templates'] . '/search/main.inc';

if ($conf['user']['online_help'] && $browser->hasFeature('javascript')) {
    Help::javascript();
}
$registry->shutdown();

require $conf['paths']['templates'] . '/common-footer.inc';

if ($conf['compress_pages']) {
    HTTP_Cache::output();
}
?>
